#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2900four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 2900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2900four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four29004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four29004xi = {
                1:'1000x-354y2698z',
                2:'1022x-2664y511z',
                3:'1043x-309y2687z',
                4:'1051x-1002y2509z',
                5:'1058x-1552y2208z',
                6:'1070x-1992y1814z',
                7:'1084x-260y2676z',
                8:'1121x-962y2495z',
                9:'1123x-208y2665z',
                10:'1151x-1512y2190z',
                11:'1158x-153y2654z',
                12:'1163x-2612y482z',
                13:'1182x-1949y1791z',
                14:'1190x-917y2480z',
                15:'1191x-94y2642z',
                16:'1221x-32y2630z',
                17:'1243x-1466y2170z',
                18:'1257x-868y2464z',
                19:'1293x-1899y1768z',
                20:'1300x-2552y453z',
                21:'1321x-814y2449z',
                22:'1333x-1415y2151z',
                23:'1383x-755y2433z',
                24:'1401x-1843y1745z',
                25:'1421x-1358y2132z',
                26:'1434x-2484y425z',
                27:'1443x-692y2418z',
                28:'147x-2814y681z',
                29:'1500x-625y2401z',
                30:'1506x-1295y2112z',
                31:'1507x-1780y1722z',
                32:'1553x-553y2385z',
                33:'1564x-2409y396z',
                34:'1588x-1228y2092z',
                35:'1602x-478y2368z',
                36:'1610x-1711y1699z',
                37:'1648x-399y2352z',
                38:'1667x-1155y2072z',
                39:'1690x-2327y367z',
                40:'1690x-317y2334z',
                41:'1709x-1636y1675z',
                42:'1727x-231y2317z',
                43:'172x-131y2891z',
                44:'1743x-1077y2051z',
                45:'1760x-142y2300z',
                46:'1788x-50y2282z',
                47:'1805x-1556y1651z',
                48:'1812x-2238y339z',
                49:'1815x-994y2031z',
                50:'1883x-906y2010z',
                51:'1897x-1469y1627z',
                52:'1929x-2142y310z',
                53:'1946x-814y1989z',
                54:'196x-556y2839z',
                55:'1985x-1377y1603z',
                56:'2005x-718y1968z',
                57:'202x-138y2889z',
                58:'2040x-2040y281z',
                59:'2058x-617y1946z',
                60:'2068x-1279y1579z',
                61:'2107x-513y1925z',
                62:'2146x-1177y1555z',
                63:'2146x-1933y252z',
                64:'2149x-406y1903z',
                65:'2186x-295y1881z',
                66:'2218x-1070y1530z',
                67:'2218x-182y1859z',
                68:'2243x-66y1836z',
                69:'2247x-1819y223z',
                70:'2285x-958y1505z',
                71:'2340x-1700y194z',
                72:'234x-143y2886z',
                73:'236x-571y2833z',
                74:'2427x-871y1531z',
                75:'2428x-1576y165z',
                76:'2508x-1448y136z',
                77:'2582x-1315y107z',
                78:'2648x-1179y78z',
                79:'267x-144y2884z',
                80:'2706x-1039y49z',
                81:'2757x-896y20z',
                82:'278x-583y2827z',
                83:'295x-2809y653z',
                84:'300x-142y2880z',
                85:'321x-593y2820z',
                86:'333x-137y2877z',
                87:'367x-129y2873z',
                88:'367x-599y2813z',
                89:'401x-118y2869z',
                90:'413x-602y2806z',
                91:'435x-103y2865z',
                92:'443x-2797y624z',
                93:'461x-602y2798z',
                94:'468x-85y2860z',
                95:'474x-1154y2617z',
                96:'500x-64y2855z',
                97:'510x-598y2791z',
                98:'531x-40y2850z',
                99:'545x-1151y2605z',
                100:'560x-591y2783z',
                101:'561x-13y2845z',
                102:'590x-2775y596z',
                103:'611x-580y2774z',
                104:'617x-1143y2592z',
                105:'661x-565y2766z',
                106:'690x-1132y2579z',
                107:'712x-546y2757z',
                108:'736x-2746y568z',
                109:'762x-524y2748z',
                110:'763x-1115y2565z',
                111:'774x-1638y2264z',
                112:'812x-498y2738z',
                113:'835x-1094y2552z',
                114:'861x-468y2729z',
                115:'869x-1615y2246z',
                116:'880x-2709y539z',
                117:'908x-1068y2538z',
                118:'909x-434y2719z',
                119:'955x-396y2709z',
                120:'964x-1586y2227z',
                121:'980x-1038y2524z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2900four4xi" usage = "target function for charge29004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2900four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2900FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2900FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2900FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2900FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2900FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four29004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2900FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2900FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2900FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four29004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four29004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2900FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2900FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2900FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2900four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    